#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_color3 White
#property indicator_color4 White
#property indicator_color5 Silver
#property indicator_color6 DodgerBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 3
#property indicator_width6 3



#include <WebGet.mqh>



extern string   xx                        = "==Mandarine==";
extern int      T3Period                  = 5;
extern int      T3Price                   = PRICE_CLOSE;
extern double   T3Hot                     = 0.7;
extern bool     T3Original                = false;
extern int      Fast                      = 5;
extern int      Slow                      = 20; 

extern string   x                         = "==Mandarine Alerts AND aRROWS==";
extern bool     UseSound                  = 1;
extern bool     CommentOnChart            = 1;
extern bool     SignalMail                = false;
extern string   NameFileSound             = "train.wav";
extern string   note7                     = "Arrow Type";
extern string   note8                     = "0=Thick, 1=Thin, 2=Hollow, 3=Round";
extern string   note9                     = "4=Fractal, 5=Diagonal Thin";
extern string   note10                    = "6=Diagonal Thick, 7=Diagonal Hollow";
extern string   note11                    = "8=Thumb, 9=Finger";
extern int      ArrowType                 = 1;

extern string   MoneyManagementSetting    = "==Money Management Settings==";
extern bool     UseAutomaticMM            = true;
extern double   Risk                      = 2.50;
extern double   BaseLot                   = 0.05;
extern double   Risk_to_Reward_ratio      = 3.0;
extern double   Range.trailingStop        = 0.25;
extern double   Range.stopLoss            = 0.25;

extern string   HeikenAshiSetting         = "==HeikenAshi Settings==";
extern bool     ShowHeikenAshi            = true; 
extern int      Length                    = 20;
extern double   Phase                     = 0;
extern int      Step                      = 1;
extern bool     BetterFormula             = true;

extern string   DailyRangeSetting         = "==Daily Range Settings==";
extern bool     Show_RangeBox             = false;
extern bool     Show_Range_hilo_line      = true;
extern bool     Show_Range_vertical_lines = false;
extern bool     Show_Rangehilo_text       = true;

extern string   boxlook                   = "==Box look=="; 
extern string   ex1                       = "Time you want box to end";
extern string   BoxEnd                    = "24:00"; 
extern string   ex2                       = "Period back you want range";
extern string   ex3                       = "box to look in bars";
extern int      BoxLenght                 = 270;  
extern color    BoxColor                  = MidnightBlue;     
extern color    clFont                    = Aqua;
extern color    toprangecolor             = OrangeRed;
extern color    bottomrangecolor          = OrangeRed;
extern color    leftvlinecolor            = DodgerBlue;

extern string   exbarclk                  = "==Barclock Settings==";
extern bool     Showbarclock              = true;
extern color    Barclockcolor             = White;
extern int      barclockfontsize          = 12;

extern string   rangecomments             = "==Range Comments==";               
extern int      ShortRange                = 5;
extern int      InterRange                = 10;
extern int      LongRange                 = 20;   

extern string   FiboPivotSetting          = "==Fibo Pivot Settings=="; 
extern bool     ShowFibPivotLines         = true;   
extern color    Resistance_3              = Magenta;
extern color    Resistance_2              = Red;
extern color    Resistance_1              = Red;
extern color    Pivot                     = Gold;
extern color    Support_1                 = LimeGreen;
extern color    Support_2                 = LimeGreen;
extern color    Support_3                 = Aqua;
extern int      Pivottimeframe            = PERIOD_D1;

extern string   _news                     = "==News Filter==";
extern string   CalendarName              = "ForexTSD";
extern int      CalendarID                = 4;     // Calendar's ID on calendar.forex-tsd.com  
extern bool     UseStartDate              = false; 
extern datetime StartDate                 = D'2007.04.10';      
extern bool     AlertMode                 = true;
extern int      AlertTimeGap              = 1;     // Time Gap between News Time and Alert Time in min 
extern bool     DisplayLine               = false; // Display Line Option (Visualization mode) 
extern bool     DisplayText               = false; // Display Text Option (Visualization mode)

extern string   cFilter                   = "==Currency Filter==";
extern bool     USD                       = true;
extern bool     EUR                       = true;
extern bool     GBP                       = true;
extern bool     JPY                       = true;
extern bool     AUD                       = true;
extern bool     CAD                       = true;
extern bool     CHF                       = true;
extern bool     NZD                       = true;

extern string   rFilter                   = "==Rating Filter==";
extern int      MaxRating                 = 3;
extern int      MinRating                 = 3;  


double   buy[];
double   sell[];
double   ExtMapBuffer5[];
double   ExtMapBuffer6[];
double   ExtMapBuffer7[];
double   ExtMapBuffer8[];
double   t3[];

int      ExtCountedBars=0;
int      last;
int      nDigits;
int      NewsNum;
int      TimeZone;

double   pointvalue=1;
double   alertTag;
double   avg.rng, rng, sum.rng;
double   emas[][6];
double   alpha;
double   c1;
double   c2;
double   c3;
double   c4;

string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sCurrency[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
string   sActual[1000];        // Actual value
string   sForecast[1000];      // Forecast value
string   sPrevious[1000];      // Previous value
string   sImpact[1000];
string   DR;

datetime dt[1000]; 
datetime prevTime, nTime, OpenTime;   

bool     fTime;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   
   
   IndicatorBuffers(7);
   if (ArrowType == 0) {
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 233);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 234);
   }
   else if (ArrowType == 1) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 225);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 226);
   }
   else if (ArrowType == 2) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 241);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 242);
   }
   else if (ArrowType == 3) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 221);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 222);
   }
   else if (ArrowType == 4) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 217);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 218);
   }
   else if (ArrowType == 5) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 228);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 230);
   }
   else if (ArrowType == 6) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 236);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 238);
   }
   else if (ArrowType == 7) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 246);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 248);
   }
   else if (ArrowType == 8) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 67);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 68);
   }
   else if (ArrowType == 9) { 
   SetIndexBuffer(0, buy);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 71);
   SetIndexBuffer(1, sell);   SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 72);
   }
   SetIndexBuffer(2, ExtMapBuffer5); SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3, ExtMapBuffer6); SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(4, ExtMapBuffer7); SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(5, ExtMapBuffer8); SetIndexStyle(5,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(6 ,t3);            SetIndexStyle(6,NULL,NULL,NULL,NULL);
   
   
   
   double a  = T3Hot;
             c1 = -a*a*a;
             c2 = 3*a*a+3*a*a*a;
             c3 = -6*a*a-3*a-3*a*a*a;
             c4 = 1+3*a+a*a*a+3*a*a;
               
   
               
      T3Period = MathMax(1,T3Period);
      if (T3Original)
           alpha = 2.0/(1.0 + T3Period);
      else alpha = 2.0/(2.0 + (T3Period-1.0)/2.0);
      
   
   return(0);
  }


int deinit()
  {
   ObjectDelete("S1");
   ObjectDelete("S2");
   ObjectDelete("S3");
   ObjectDelete("SS");   
   ObjectDelete("R1");
   ObjectDelete("R2");
   ObjectDelete("R3");
   ObjectDelete("SR");    
   ObjectDelete("PIVOT");
   ObjectDelete("Support 1");
   ObjectDelete("Support 2");
   ObjectDelete("Support 3");
   ObjectDelete("Pivot level");
   ObjectDelete("Resistance 1");
   ObjectDelete("Resistance 2");
   ObjectDelete("Resistance 3");  
   ObjectDelete("TDR2");
   ObjectDelete("TDR2 Line"); 
   ObjectDelete("BDR2");
   ObjectDelete("BDR2 Line");    
   Comment(" "); 
   ObjDel();
   return(0);
  }

//------------------------------------------------------------------  

//------------------------------------------------------------------
int start()
  {
      double emaf11,emaf12,emas21,emas22,t3x;
      int counted_bars=IndicatorCounted();
      int j,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
            
      for(j=limit; j>=0; j--)
      {
      t3[j]  = t3x;
      t3x    = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,j),j);
      emaf11 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,j);
      emaf12 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,j+1);
      emas21 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,j);
      emas22 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,j+1);
   	
      if (emaf11 > emas21 && emaf12 <= emas22 && emaf11 > t3x) {
         buy[j] = Low[j] - iATR(NULL,0,20,j)/2.0;
      if (alertTag!= Time[0])
         {
         if (UseSound == 1) 
	         PlaySound(NameFileSound);
         if (CommentOnChart == 1) 
             Alert(Symbol(),"  ",Period(),"Mandarine cross Buy");
         if (SignalMail) SendMail("[Signal Alert from Mandarine System]",  " [" + TimeCurrent() + "] " + "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Mandarine cross Buy");
             alertTag = Time[0];
            }
      }
      else if (emaf11 < emas21 && emaf12 >= emas22 && emaf11 < t3x) {
         sell[j] = High[j] + iATR(NULL,0,20,j)/2.0;
         if ( alertTag!= Time[0])
         {
         if (UseSound == 1) 
	         PlaySound(NameFileSound);
         if (CommentOnChart == 1) 
             Alert(Symbol(),"  ",Period(),"Mandarine cross Sell");
         if (SignalMail) SendMail("[Signal Alert from Mandarine System]",  " [" + TimeCurrent() + "] " + "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Mandarine cross Sell");
            alertTag = Time[0];
      }
    }
   }
//+------------------------------------------------------------------+
//| Heiken Ashi indicator iteration function                              
//+------------------------------------------------------------------+
if (ShowHeikenAshi)
{
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haClose, haLow, haHigh; 
   counted_bars = IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = Bars-counted_bars;  
      
         
      for(int pos=limit; pos >= 0; pos--)
      {
      maOpen  = iSmooth(Open[pos], Length,Phase,pos,0);
      maClose = iSmooth(Close[pos],Length,Phase,pos,10);
      maLow   = iSmooth(Low[pos],  Length,Phase,pos,20);
      maHigh  = iSmooth(High[pos], Length,Phase,pos,30);
      
      if (BetterFormula) {
               if (maHigh!=maLow)
                     haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose = (maOpen+maClose)/2; }
         else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                     haOpen   = (ExtMapBuffer7[pos+1]+ExtMapBuffer8[pos+1])/2;
                     haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                     haLow    = MathMin(maOpen,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { ExtMapBuffer5[pos]=haLow;  ExtMapBuffer6[pos]=haHigh; } 
         else                { ExtMapBuffer5[pos]=haHigh; ExtMapBuffer6[pos]=haLow;  } 
                               ExtMapBuffer7[pos]=haOpen;
                               ExtMapBuffer8[pos]=haClose;
      
      //
      //
      //
      //
      //

      if (Step>0)
      {
         if( MathAbs(ExtMapBuffer5[pos]-ExtMapBuffer5[pos+1]) < Step*pointvalue) ExtMapBuffer5[pos]=ExtMapBuffer5[pos+1];
         if( MathAbs(ExtMapBuffer6[pos]-ExtMapBuffer6[pos+1]) < Step*pointvalue) ExtMapBuffer6[pos]=ExtMapBuffer6[pos+1];
         if( MathAbs(ExtMapBuffer7[pos]-ExtMapBuffer7[pos+1]) < Step*pointvalue) ExtMapBuffer7[pos]=ExtMapBuffer7[pos+1];
         if( MathAbs(ExtMapBuffer8[pos]-ExtMapBuffer8[pos+1]) < Step*pointvalue) ExtMapBuffer8[pos]=ExtMapBuffer8[pos+1];
      }            
   }
}
 
   double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
   ArrayCopyRates(rates, Symbol(), Pivottimeframe);
   if(DayOfWeek() == 1)
   {
   if(TimeDayOfWeek(iTime(Symbol(),Pivottimeframe,1)) == 5)
   {
   yesterday_close = rates[1][4];
   yesterday_high = rates[1][3];
   yesterday_low = rates[1][2];
   }
   else
   {
   for(int d = 5;d>=0;d--)
   {
   if(TimeDayOfWeek(iTime(Symbol(),Pivottimeframe,d)) == 5)
   {
   yesterday_close = rates[d][4];
   yesterday_high = rates[d][3];
   yesterday_low = rates[d][2];
   }     
   }    
   }
   }
   else
   {
   yesterday_close = rates[1][4];
   yesterday_high = rates[1][3];
   yesterday_low = rates[1][2];
   }
   double R = yesterday_high - yesterday_low;//range
   double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
   double r3 = p + (R * 1.000);
   double r2 = p + (R * 0.618);
   double r1 = p + (R * 0.382);
   double s1 = p - (R * 0.382);
   double s2 = p - (R * 0.618);
   double s3 = p - (R * 1.000);
   double day_high=0;
   double day_low=0;
   double nQ=0;
   double nD=0;
   double D=0;
   double Q=0;
   day_high = rates[0][3];
   day_low = rates[0][2];
   D = (day_high - day_low);
   Q = (yesterday_high - yesterday_low);
   double fb,fs,fe,tp1,tp2,tp3;
   double ri,re1,re2,re3,ra1,ra2,ra3;
   if (Q > 5) 
   {
	nQ = Q;
   }
   else
   {
	nQ = Q*10000;
   }

   if (D > 5)
   {
	nD = D;
   }
   else
   {
	nD = D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   nQ=nQ/100;
   nD=nD/100;     
   }
   if (ShowFibPivotLines){
   drawLine(r3,"R3", Resistance_3,1);
   drawLabel("Resistance 3",r3,Resistance_3);
   drawLine(r2,"R2", Resistance_2,2);
   drawLabel("Resistance 2",r2,Resistance_2);
   drawLine(r1,"R1", Resistance_1,0);
   drawLabel("Resistance 1",r1,Resistance_1);

   drawLine(p,"PIVOT",Pivot,1);
   drawLabel("Pivot level",p,Pivot);

   drawLine(s1,"S1",Support_1,0);
   drawLabel("Support 1",s1,Support_1);
   drawLine(s2,"S2",Support_2,2);
   drawLabel("Support 2",s2,Support_2);
   drawLine(s3,"S3",Support_3,1);
   drawLabel("Support 3",s3,Support_3);
   }
    if(Showbarclock) {
   
   double ii;
   int mm,ss,k;
   mm=Time[0]+Period()*60-CurTime();
   ii=mm/60.0;
   ss=mm%60;
   mm=(mm-mm%60)/60;
	
   ObjectDelete("[PivotsD]  time");
   if(ObjectFind("[PivotsD]  time") != 0)
   {
   ObjectCreate("[PivotsD] time", OBJ_TEXT, 0, Time[0], Close[0]+ 0.0005);
   ObjectSetText("[PivotsD] time", "                  <"+mm+":"+ss, barclockfontsize, "Arial", Barclockcolor);
   }
   else
   {
   ObjectMove("[PivotsD] time", 0, Time[0], Close[0]+0.0005);
   }
   }  

//+------------------------------------------------------------------+
//| Daily Range iteration function                              
//+------------------------------------------------------------------+ 
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0,StopLoss_Long=0,StopLoss_Short=0;
   int i=0;
   double trailingStop;
   double SL_Long=0,SL_Short=0;
   double low0=0,high0=0,low1=0,high1=0;
   
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/pointvalue;
   for(i=1;i<=5;i++)
   R5 = R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;
   for(i=1;i<=10;i++)
   R10 = R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;
   for(i=1;i<=20;i++)
   R20 = R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;

   R5 = R5/ShortRange;
   R10 = R10/InterRange;
   R20 = R20/LongRange;
   RAvg  =  (R1+R5+R10+R20)/4;    

   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   low1  =  iLow(NULL,PERIOD_D1,1);
   high1 =  iHigh(NULL,PERIOD_D1,1);
   RoomUp   =  RAvg - (Bid - low0)/pointvalue;
   RoomDown =  RAvg - (high0 - Bid)/pointvalue;
   StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   SL_Long        =  Bid - StopLoss_Long*pointvalue;
   StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   SL_Short       =  Bid + StopLoss_Short*pointvalue; 
   trailingStop   = Range.trailingStop*RAvg;
      
   RefreshRates();
   double step   = MarketInfo(Symbol(),MODE_LOTSTEP);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(R1*Range.stopLoss*MarketInfo(Symbol(),MODE_TICKVALUE)/pointvalue);
      }
   }
   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   datetime cTime = iTime(NULL,PERIOD_W1,0);
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;  
   string cName = ForexTSD_Calendar();  
      
   if(cName != "")
   {   
   ReadnPlotCalendar(cName);
   fTime = false;
   prevTime = cTime;
   }
   else 
   {  
   return(0);
   }
   }
   if(AlertMode && TimeToAlert() && TimeCurrent() > nTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nTime = TimeCurrent() + AlertTimeGap*60;
   }           
   
   for (i=0; i<=NewsNum-1; i++)
   { 
   if(TimeCurrent()> dt[i-1] && TimeCurrent() <= dt[i])
   {
   OpenTime = dt[i];
   string upcomNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+" Actual=" + sPrevious[i]+" Forecast=" + sForecast[i];  
   string upcomTime = TimeToStr(dt[i]);  
         
   if (i-1 >= 0)
   {
   string prevNews = sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i]; 
   string prevTime = TimeToStr(dt[i-1]);
   }
   }
      
   if(OpenTime > 0 && OpenTime < dt[i])
   {
   string nextNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+" Actual=" + sPrevious[i]+" Forecast=" + sForecast[i]; 
   string nextTime = TimeToStr(dt[i]);
   break;
   }
   }
   sComment = sp;
   sComment = sComment+"Mandarine Trading System"+NL; 
   sComment = sComment+"ForexTSD Calendar:"+NL;
    
   if(TimeZone >= 0)
   
   sComment = sComment+"Broker\'s Time Zone : GMT + " + TimeZone + NL;
   else
   sComment = sComment+"Broker\'s Time Zone : GMT - " + MathAbs(TimeZone) + NL;
   
   if(MarketInfo(Symbol(),MODE_SWAPLONG)>0) string swap="longs,";
   else swap="shorts.";
   if(MarketInfo(Symbol(),MODE_SWAPLONG)<0 && MarketInfo(Symbol(),MODE_SWAPSHORT)<0) swap="your broker. ";
   int Spread    = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);
   if( StringFind( Symbol(), "JPY", 0) != -1 )
   { nDigits  = 2;}
   else { nDigits  = 4; }  
   
   sComment = sComment+"NEWS :" + NL;
   sComment = sComment+"Previous = " + prevTime  +" "+prevNews  + NL;
   sComment = sComment+"Upcoming = " + upcomTime +" "+upcomNews + NL;
   sComment = sComment+"Next = " + nextTime +" "+nextNews + NL;
   sComment = sComment + sp + NL;  
   sComment = sComment+"Swap favors " + swap + NL; 
   sComment = sComment+"Swap  Long =   "+DoubleToStr(MarketInfo(Symbol(),MODE_SWAPLONG),nDigits) + NL;
   sComment = sComment+"Swap  Short=   "+DoubleToStr(MarketInfo(Symbol(),MODE_SWAPSHORT),nDigits) +  NL; 
   sComment = sComment+"Current Spread = " + DoubleToStr(Spread,nDigits) + NL; 
   sComment = sComment + sp + NL; 
   sComment = sComment+"Average Daily Range = " + RAvg + NL; 
   sComment = sComment+"Prev 01 Day Range = " + R1 + NL;
   sComment = sComment+"Short Term Range = " + R5 + NL;
   sComment = sComment+"Intermediate Range = " + R10 + NL;
   sComment = sComment+"Long Term Range = " + R20 + NL;
   sComment = sComment+"Todays Range = " + R5 + NL;
   sComment = sComment+"Room Up = " + RoomUp + NL;
   sComment = sComment+"Room Down = " + RoomDown + NL;
   sComment = sComment + sp + NL;
   sComment = sComment+"Recommended Lotsize =   " + DoubleToStr(BaseLot,nDigits) +   "Lots"  + NL;
   sComment = sComment+"Risk to Reward_ratio =  " + DoubleToStr(Risk_to_Reward_ratio,nDigits) + NL;
   sComment = sComment+"Maximum StopLosses :"  + NL;
   sComment = sComment+"Long:  " + StopLoss_Long  + " Pips at " + DoubleToStr(SL_Long,nDigits)  + NL;
   sComment = sComment+"Short: " + StopLoss_Short + " Pips at " + DoubleToStr(SL_Short,nDigits) + NL;
   sComment = sComment+"Trailing Stop = " + DoubleToStr(trailingStop,nDigits) +  NL; 
   sComment = sComment + sp + NL; 
  
   Comment(sComment);        

return(0);
}

  
void ReadnPlotCalendar(string fName)
{    
   int i,handle;
   bool rates=false;
   
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
   i=0;
   while(!FileIsEnding(handle))
   {
   sDate[i]=FileReadString(handle);          
   sTime[i]=FileReadString(handle);         
   sCurrency[i]=FileReadString(handle);      
   sDescription[i]=FileReadString(handle);   
   sRating[i]=FileReadString(handle);        
   sActual[i]=FileReadString(handle);       
   sForecast[i]=FileReadString(handle);      
   sPrevious[i]=FileReadString(handle);                
   
   int rating = StrToInteger(sRating[i]);
   rates = rating <= MaxRating && rating >= MinRating;
      
   if(!rates) continue;  
   
   if ((sCurrency[i] == "USD") && (!USD)) continue;            
   if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
   if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
   if ((sCurrency[i] == "JPY") && (!JPY)) continue;
   if ((sCurrency[i] == "AUD") && (!AUD)) continue;
   if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
   if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
   if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
      
   dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   if(rating == 3) sImpact[i] = "High";
   if(rating == 2) sImpact[i] = "Medium";
   if(rating == 1) sImpact[i] = "Low";
   
   string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i];
   color c=Yellow ;
   
   if (sCurrency[i] == "USD") c = Blue;  
   if (sCurrency[i] == "EUR") c = Pink; 
   if (sCurrency[i] == "GBP") c = Red;
   if (sCurrency[i] == "JPY") c = Orange;            
   if (sCurrency[i] == "AUD") c = Green;       
   if (sCurrency[i] == "CAD") c = Gray;
   if (sCurrency[i] == "CHF") c = Green;
   if (sCurrency[i] == "NZD") c = Lime;  
      
      if (DisplayText)
      {
      ObjectCreate("TSDT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
      ObjectSet("TSDT"+i, OBJPROP_COLOR, c);          
      ObjectSetText("TSDT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
      ObjectSet("TSDT"+i, OBJPROP_ANGLE, 90);          
      }   
      if (DisplayLine)
      {         
      ObjectCreate("TSDL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
      ObjectSet("TSDL"+i, OBJPROP_COLOR, c);                    
      ObjectSet("TSDL"+i, OBJPROP_STYLE, STYLE_DOT);                    
      ObjectSet("TSDL"+i, OBJPROP_BACK, true);          
      ObjectSetText("TSDL"+i,sDescription[i] + "  ",8);          
      }
   i++;
   }
   NewsNum = i;
   
return(0);
}
string ForexTSD_Calendar()
{
   if(!UseStartDate)
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   else 
   StartWeek = StartDate;
   
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>9) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   if (TimeDay(StartWeek)>9) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}


void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 8, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}


void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
   if (DisplayLine)
   if ( !ObjectDelete( StringConcatenate( "TSDL", i ) ) )
   {
   _GetLastError = GetLastError();
   } 
   if (DisplayText)
   if( !ObjectDelete( StringConcatenate( "TSDT", i ) ) )
   {
   _GetLastError = GetLastError();
   }
  }
}

bool TimeToAlert()
   {
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

double iT3(double price,int shift)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0] = price;
         emas[i][1] = price;
         emas[i][2] = price;
         emas[i][3] = price;
         emas[i][4] = price;
         emas[i][5] = price;
      }
   else
      {
         emas[i][0] = emas[i-1][0]+alpha*(price     -emas[i-1][0]);
         emas[i][1] = emas[i-1][1]+alpha*(emas[i][0]-emas[i-1][1]);
         emas[i][2] = emas[i-1][2]+alpha*(emas[i][1]-emas[i-1][2]);
         emas[i][3] = emas[i-1][3]+alpha*(emas[i][2]-emas[i-1][3]);
         emas[i][4] = emas[i-1][4]+alpha*(emas[i][3]-emas[i-1][4]);
         emas[i][5] = emas[i-1][5]+alpha*(emas[i][4]-emas[i-1][5]);
      }
   return(c1*emas[i][5] + c2*emas[i][4] + c3*emas[i][3] + c4*emas[i][2]);
}

